module Synthesizer.Inference.Monad.File where

import qualified Synthesizer.Basic.Binary as BinSmp

import qualified Synthesizer.Inference.Monad.Signal  as SigI
import qualified Synthesizer.Physical.File     as FileP

import System.Exit(ExitCode)

import qualified Algebra.OccasionallyScalar as OccScalar
import qualified Algebra.Algebraic          as Algebraic
import qualified Algebra.VectorSpace        as VectorSpace
import qualified Algebra.RealField          as RealField


writeToInt16 ::
   (RealField.C a, Algebraic.C q, Ord q, BinSmp.C v,
    OccScalar.C a q, VectorSpace.C a v) =>
   q -> q -> FilePath -> SigI.Process a q v -> IO ExitCode
writeToInt16 freqUnit amp name proc =
   FileP.writeToInt16 freqUnit amp name (SigI.run proc)
